/*
   ipc.h
   Written by Richard Dawe <richdawe@bigfoot.com>
*/

#ifdef __cplusplus
extern "C" {
#endif

#ifndef __sys_ipc_h__
#define __sys_ipc_h__

#include <sys/types.h>

/* Out-of-place definitions */
typedef int key_t;

/* --- Defines --- */

/* Mode bits - these should be greater than the S_* file permissions. */
#define IPC_CREAT	0x200
#define IPC_EXCL	0x400
#define IPC_NOWAIT	0x800

/* Keys */
#define IPC_PRIVATE	-1

/* Control commands */
#define IPC_RMID	1
#define IPC_SET		2
#define IPC_STAT	4

/* --- Types --- */

struct ipc_perm {
	uid_t  uid;
	gid_t  gid;
	uid_t  cuid;
	gid_t  cgid;
	mode_t mode;
};

/* Functions */

extern key_t ftok (const char *path, int id);

#endif	/* __sys_ipc_h__ */

#ifdef __cplusplus
}
#endif
