/*
 * shm.h - Shared memory functions & data structures
 * Written by Richard Dawe <richdawe@bigfoot.com>
 */

#ifdef __cplusplus
extern "C" {
#endif

#ifndef __sys_shm_h__
#define __sys_shm_h__

#include <sys/types.h>
#include <time.h>
#include <sys/ipc.h>

/* --- Defines --- */

/* shmat flags */
#define SHM_RDONLY	1
#define SHM_RND		2

/* TODO: This should allow the buffer to be aligned in memory! */
#define SHMLBA 0

/* --- Types --- */
typedef unsigned short shmatt_t;

struct shmid_ds {
	struct ipc_perm shm_perm;
	size_t          shm_segsz;
	pid_t           shm_lpid;
	pid_t           shm_cpid;
	shmatt_t        shm_nattch;
	time_t          shm_atime;
	time_t          shm_dtime;
	time_t          shm_ctime;
};

/* --- Functions --- */

extern void *shmat  (int shmid, const void *shmaddr, int shmflag);
extern int   shmctl (int shmid, int cmd, struct shmid_ds *buf);
extern int   shmdt  (const void *shmaddr);
extern int   shmget (key_t key, size_t size, int shmflg);

#endif	/* __sys_shm_h__ */

#ifdef __cplusplus
}
#endif
